# wxProcess Class Reference
[Application and Process Management]

`#include <wx/process.h>`

Inheritance diagram for wxProcess:
[legend]

## Detailed Description

The objects of this class are used in conjunction with the wxExecute() function.

When a wxProcess object is passed to wxExecute(), its OnTerminate() virtual method is called when the process terminates. This allows the program to be (asynchronously) notified about the process termination and also retrieve its exit status which is unavailable from wxExecute() in the case of asynchronous execution.

Note:
  If the `wxEVT_END_PROCESS` event sent after termination is processed by the parent, then it is responsible for deleting the wxProcess object which sent it. However, if it is not processed, the object will delete itself and so the library users should only delete those objects whose notifications have been processed (and call wxProcess::Detach for others). This also means that unless you're going to process the `wxEVT_END_PROCESS` event, you must allocate the wxProcess class on the heap.

wxProcess also supports IO redirection of the child process. For this, you have to call its Redirect() method before passing it to wxExecute(). If the child process was launched successfully, GetInputStream(), GetOutputStream() and GetErrorStream() can then be used to retrieve the streams corresponding to the child process standard output, input and error output respectively.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxProcessEvent& event)
Event macros for events emitted by this class:

- EVT_END_PROCESS(id, func):
  Process a `wxEVT_END_PROCESS` event, sent by wxProcess::OnTerminate upon the external process termination.

##

Library: wxBase

Category: Application and Process Management

wxPerl Note: In wxPerl this class has an additional `Destroy` method, for explicit destruction.

See also:
  wxExecute(), External Program Execution Sample

## Public Member Functions
| wxProcess (wxEvtHandler *parent=NULL, int id=-1)
| Constructs a process object.
| wxProcess (int flags)
| Creates an object without any associated parent (and hence no id neither) but allows to specify the flags which can have the value of `wxPROCESS_DEFAULT` or `wxPROCESS_REDIRECT`.
virtual | ~wxProcess ()
| Destroys the wxProcess object.
void | CloseOutput ()
| Closes the output stream (the one connected to the stdin of the child process).
void | Detach ()
| Detaches this event handler from the parent specified in the constructor (see wxEvtHandler::Unlink() for a similar but not identic function).
wxInputStream * | GetErrorStream () const
| Returns an input stream which corresponds to the standard error output (stderr) of the child process.
wxInputStream * | GetInputStream () const
| It returns an input stream corresponding to the standard output stream of the subprocess.
wxOutputStream * | GetOutputStream () const
| It returns an output stream corresponding to the input stream of the subprocess.
long | GetPid () const
| Returns the process ID of the process launched by Open() or set by wxExecute() (if you passed this wxProcess as argument).
bool | IsErrorAvailable () const
| Returns true if there is data to be read on the child process standard error stream.
bool | IsInputAvailable () const
| Returns true if there is data to be read on the child process standard output stream.
bool | IsInputOpened () const
| Returns true if the child process standard output stream is opened.
virtual void | OnTerminate (int pid, int status)
| It is called when the process with the pid pid finishes.
void | Redirect ()
| Turns on redirection.
## Static Public Member Functions
static bool | Exists (int pid)
| Returns true if the given process exists in the system.
static wxKillError | Kill (int pid, wxSignal sig=wxSIGTERM, int flags=wxKILL_NOCHILDREN)
| Send the specified signal to the given process.
static wxProcess * | Open (const wxString &cmd, int flags=wxEXEC_ASYNC)
| This static method replaces the standard `popen()` function: it launches the process specified by the cmd parameter and returns the wxProcess object which can be used to retrieve the streams connected to the standard input, output and error output of the child process.

List of all members.

## Constructor & Destructor Documentation

wxProcess::wxProcess | ( | wxEvtHandler * | parent = `NULL`,
|  | int | id = `-1` |
| ) |  |  |

Constructs a process object.

id is only used in the case you want to use wxWidgets events. It identifies this object, or another window that will receive the event.

If the parent parameter is different from NULL, it will receive a `wxEVT_END_PROCESS` notification event (you should insert `EVT_END_PROCESS` macro in the event table of the parent to handle it) with the given id.

Parameters:

  | parent | The event handler parent.
  | id | id of an event.

wxProcess::wxProcess | ( | int | flags | ) |

Creates an object without any associated parent (and hence no id neither) but allows to specify the flags which can have the value of `wxPROCESS_DEFAULT` or `wxPROCESS_REDIRECT`.

Specifying the former value has no particular effect while using the latter one is equivalent to calling Redirect().

virtual wxProcess::~wxProcess | ( |  | ) | `[virtual]`

Destroys the wxProcess object.

## Member Function Documentation

void wxProcess::CloseOutput | ( |  | ) |

Closes the output stream (the one connected to the stdin of the child process).

This function can be used to indicate to the child process that there is no more data to be read - usually, a filter program will only terminate when the input stream is closed.

Notice that GetOutputStream() will return NULL after the output stream is closed.

void wxProcess::Detach | ( |  | ) |

Detaches this event handler from the parent specified in the constructor (see wxEvtHandler::Unlink() for a similar but not identic function).

Normally, a wxProcess object is deleted by its parent when it receives the notification about the process termination.

However, it might happen that the parent object is destroyed before the external process is terminated (e.g. a window from which this external process was launched is closed by the user) and in this case it should not delete the wxProcess object, but should call Detach() instead.

After the wxProcess object is detached from its parent, no notification events will be sent to the parent and the object will delete itself upon reception of the process termination notification.

static bool wxProcess::Exists | ( | int | pid | ) | `[static]`

Returns true if the given process exists in the system.

See also:
  Kill(), Exec sample

wxInputStream* wxProcess::GetErrorStream | ( |  | ) | const

Returns an input stream which corresponds to the standard error output (stderr) of the child process.

wxInputStream* wxProcess::GetInputStream | ( |  | ) | const

It returns an input stream corresponding to the standard output stream of the subprocess.

If it is NULL, you have not turned on the redirection.

See also:
  Redirect().

wxOutputStream* wxProcess::GetOutputStream | ( |  | ) | const

It returns an output stream corresponding to the input stream of the subprocess.

If it is NULL, you have not turned on the redirection or already called CloseOutput().

See also:
  Redirect().

long wxProcess::GetPid | ( |  | ) | const

Returns the process ID of the process launched by Open() or set by wxExecute() (if you passed this wxProcess as argument).

bool wxProcess::IsErrorAvailable | ( |  | ) | const

Returns true if there is data to be read on the child process standard error stream.

See also:
  IsInputAvailable()

bool wxProcess::IsInputAvailable | ( |  | ) | const

Returns true if there is data to be read on the child process standard output stream.

This allows to write simple (and extremely inefficient) polling-based code waiting for a better mechanism in future wxWidgets versions. See the exec sample for an example of using this function.

See also:
  IsInputOpened()

bool wxProcess::IsInputOpened | ( |  | ) | const

Returns true if the child process standard output stream is opened.

static wxKillError wxProcess::Kill | ( | int | pid,
|  | wxSignal | sig = `wxSIGTERM`,
|  | int | flags = `wxKILL_NOCHILDREN` |
| ) |  |  | `[static]`

Send the specified signal to the given process.

Possible signal values can be one of the wxSignal enumeration values.

`wxSIGNONE`, `wxSIGKILL` and `wxSIGTERM` have the same meaning under both Unix and Windows but all the other signals are equivalent to `wxSIGTERM` under Windows.

The flags parameter can be `wxKILL_NOCHILDREN` (the default), or `wxKILL_CHILDREN`, in which case the child processes of this process will be killed too. Note that under Unix, for `wxKILL_CHILDREN` to work you should have created the process passing `wxEXEC_MAKE_GROUP_LEADER`.

Returns the element of wxKillError enum.

See also:
  Exists(), wxKill(), Exec sample

virtual void wxProcess::OnTerminate | ( | int | pid,
|  | int | status |
| ) |  |  | `[virtual]`

It is called when the process with the pid pid finishes.

It raises a wxWidgets event when it isn't overridden.

Note that this function won't be called if you Kill() the process.

Parameters:

  | pid | The pid of the process which has just terminated.
  | status | The exit code of the process.

static wxProcess* wxProcess::Open | ( | const wxString & | cmd,
|  | int | flags = `wxEXEC_ASYNC` |
| ) |  |  | `[static]`

This static method replaces the standard `popen()` function: it launches the process specified by the cmd parameter and returns the wxProcess object which can be used to retrieve the streams connected to the standard input, output and error output of the child process.

If the process couldn't be launched, NULL is returned.

Remarks:
  In any case the returned pointer should not be deleted, rather the process object will be destroyed automatically when the child process terminates. This does mean that the child process should be told to quit before the main program exits to avoid memory leaks.

Parameters:

  | cmd | The command to execute, including optional arguments.
  | flags | The flags to pass to wxExecute(). Note: `wxEXEC_SYNC` should not be used.

Returns:
  A pointer to new wxProcess object or NULL on error.

See also:
  wxExecute()

void wxProcess::Redirect | ( |  | ) |

Turns on redirection.

wxExecute() will try to open a couple of pipes to catch the subprocess stdio. The caught input stream is returned by GetOutputStream() as a non-seekable stream. The caught output stream is returned by GetInputStream() as a non-seekable stream.

|  | [ top ]